#include <stdio.h>
#include <stdlib.h>
#include <ao/ao.h>


static int playing;

static ao_device *device;
static int driver=-1;
static ao_sample_format format;
static int ao_initialized;

void audio_close_device(void)
{
    playing=0;
    if (device) {
	ao_close(device);
        device=NULL;
    }
}

void init_ao(int rate)
{
	format.bits = 16;
	format.channels = 1;
	format.rate = rate;
	format.byte_format = AO_FMT_LITTLE;

	if (!ao_initialized) ao_initialize();
        ao_initialized=1;
	if (driver == -1) {
		driver = ao_default_driver_id();
		if (driver == -1) {
                    fprintf(stderr,"Cannot find audio driver\n");
                    exit(1);
		}
	}
	if (!device) device = ao_open_live(driver, &format, NULL);
	if (!device) {
            fprintf(stderr,"Cannot open audio device\n");
            exit(1);
	}
}

void play_audio(short *samples,int nsamples)
{
	int rc;
	rc=ao_play(device,(char *)samples,2*nsamples);
	if (!rc) {
		audio_close_device();
		fprintf(stderr,"Libao error\n");
                exit(1);
	}
}

